function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var _ = require('lodash');

var utilities = require('./utilities');

var Population =
/*#__PURE__*/
function () {
  function Population() {
    _classCallCheck(this, Population);

    this.createProperties.apply(this, arguments);
    this.init.apply(this, arguments);
  }

  _createClass(Population, [{
    key: "init",
    value: function init(_ref) {
      var maximumSize = _ref.maximumSize,
          members = _ref.members;
      !members && this.fill();
      this.sortMembers();
    }
  }, {
    key: "createProperties",
    value: function createProperties(_ref2) {
      var maximumSize = _ref2.maximumSize,
          members = _ref2.members;
      Object.defineProperty(this, '_maximumSize', {
        writable: false,
        value: maximumSize || _.size(members),
        enumerable: false
      });
      Object.defineProperty(this, 'members', {
        writable: true,
        value: members || [],
        enumerable: true
      });
    }
  }, {
    key: "getCurrentSize",
    value: function getCurrentSize() {
      return _.size(this.getMembers());
    }
  }, {
    key: "getMaximumSize",
    value: function getMaximumSize() {
      return this._maximumSize;
    }
  }, {
    key: "getRefillThreshhold",
    value: function getRefillThreshhold() {
      return this.getMaximumSize() / 3;
    }
  }, {
    key: "getMembers",
    value: function getMembers() {
      return this.members;
    }
  }, {
    key: "sortMembers",
    value: function sortMembers() {
      this.members = _.sortBy(this.members, function (member) {
        return member.getFitness();
      });
      return this.getMembers();
    }
  }, {
    key: "getElitism",
    value: function getElitism() {
      return .2;
    }
  }, {
    key: "runGeneration",
    value: function runGeneration() {
      this.kill();
      this.mate();
      this.fill();
      this.sortMembers();
      return this;
    }
  }, {
    key: "age",
    value: function age(duration) {
      return _.reduce(_.range(0, duration), function (population, idx) {
        population.runGeneration(); //console.log(idx, _.last(population.getMembers()));

        return population;
      }, this);
    }
  }, {
    key: "addMember",
    value: function addMember(member) {
      this.members = _.concat(this.getMembers(), member);
      return this.getMembers();
    }
  }, {
    key: "createChromosome",
    value: function createChromosome() {
      throw new Error('Must supply createChromosome method');
    }
  }, {
    key: "fill",
    value: function fill() {
      while (this.getCurrentSize() < this.getMaximumSize()) {
        if (this.getCurrentSize() < this.getRefillThreshhold()) {
          this.addMember(this.createChromosome());
        } else {
          this.addMember(this.mate());
        }
      }
    }
  }, {
    key: "kill",
    value: function kill() {
      var membersToKeep = Math.floor(this.getCurrentSize() * this.getElitism());
      this.members = _.slice(this.getMembers(), -membersToKeep);
      return this.getMembers();
    }
  }, {
    key: "mate",
    value: function mate() {
      var self = this;
      var mate1Index = utilities.getRandomInt(0, this.getCurrentSize());

      var mate2Index = function findMate(previousIndex) {
        var nextIndex = utilities.getRandomInt(0, self.getCurrentSize());
        return previousIndex == nextIndex ? findMate(nextIndex) : nextIndex;
      }(mate1Index);

      var mate1 = _.get(this.getMembers(), mate1Index);

      var mate2 = _.get(this.getMembers(), mate2Index);

      return mate1.mate(mate2);
    }
  }]);

  return Population;
}();

module.exports = Population;